/*   E-scape
     Copyright (C) 1997 Free Software Foundation, Inc.
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _SRC_NETP_H
#define _SRC_NETP_H

#include <X11/CompositeP.h>
#include <src/Net.h>

typedef struct history_struct {
  struct history_struct *next, *back;
  char *url, *title, *post_data;
  size_t post_count;
} history_struct;

typedef struct {
  /* methods */
  /* class variables */
  int dummy;
} NetClassPart;

typedef struct _NetClassRec {
  CoreClassPart core_class;
  CompositeClassPart composite_class;
  NetClassPart Net_class;
} NetClassRec;

typedef struct {
  /* resources */
  XtCallbackList activate;
  XtCallbackList done;
  XtCallbackList title;
  XtCallbackList info;
  /* private state */
  struct net_connection *net;
  history_struct *history;
  html_parser_state *state;
  GC gc;
} NetPart;

typedef struct _NetRec {
  CorePart core;
  CompositePart composite;
  NetPart Net;
} NetRec;

externalref NetClassRec netClassRec;

#endif /* _SRC_NETP_H */
