/*   E-scape css inheritance header
     Copyright (C) 1997 Free Software Foundation, Inc.
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

/*
   cssprop.in is the canonical source.  cssprop.h and cssinherit.h and
   csstypeless.h are automatically generated from cssprop.in.

   cssprop.h is made by using `sed' to delete the string `'.
   That way, it contains a list of all css properties, whether or
   not they are inherited.

   cssinherit.h is made by using `grep -v' to remove lines containing
   `'.

   csstypeless.h is made by using `sed' to delete the string `',
   and converting `_int(', `_length(', `_color(', `_string(', and `_vector('
   to `('.  (It is done this way so that `background_color' won't
   get mangled.)  NOTE: FOR VARIOUS ARCANE REASONS, `_border(' IS NOT
   MANGLED.

   Note that the three above paragraphs are mangled if you are reading this
   comment in cssprop.h or cssinherit.h or csstypeless.h.

   The resulting headers are included in cssinherit.c several times.  They
   defines a list of objects in the `struct css_properties', listing their
   type and whether or not to inherit them.

   This header assumes that several macros will be defined:

   `inherit_int' is used for inheriting things which are handled
   as integers, enums, etc.  It is important to note that a value
   of 0 univerally means `undefined; look for another value from
   somewhere else'.

   `inherit_string' uses 0 to mean undefined, and a pointer to
   a valid null-terminated string when defined.

   `inherit_color' and `inherit_length' are used for `struct css_color'
   and `struct css_length', repectively.

   `inherit_vector' is used for the type used by `font-family'.

   `inherit_border' calls other macros; it's only needed because
   the `.' character in the _priority macros was breaking things.

   For all of the above macros, there is also a version with `'
   prepended, which is used when the value from the parent should not
   be inherited.

   All of the above macros take one arguement, which is the name of
   a field in `struct css_properties'.

   This file exists only to eliminate redunancy that would exist for various
   properties represented by the same C variable type.  Various adjustments
   are required for length properties and `font-wieght'.  Those adjustments
   differ enough that we do not use this header to make them.

   It is important to make sure that comments are either one line,
   or have the start and stop characters on lines with no text that
   will get deleted by the `grep -v'.

 */

  inherit_vector (font_family);
  inherit_int (font_style);
  inherit_int (font_variant);
  inherit_int (font_weight);
  inherit_length (font_size);
  inherit_color (color);
  inherit_color (background_color);
  inherit_string (background_url);
  inherit_int (background_repeat);
  inherit_int (background_scroll);
  inherit_length (background_position_x);
  inherit_length (background_position_y);
  inherit_length(word_spacing);
  inherit_length(letter_spacing);
  inherit_int (text_decoration);
  inherit_length (vertical_align);
  inherit_int (text_transform);
  inherit_length (text_indent);
  /*
     line_height is declared with `' because it can't use the standard
     inheritance semantics.
   */
  inherit_length (line_height);
  inherit_int (text_align);
  inherit_length (margin_top);
  inherit_length (margin_bottom);
  inherit_length (margin_left);
  inherit_length (margin_right);
  inherit_length (padding_top);
  inherit_length (padding_bottom);
  inherit_length (padding_left);
  inherit_length (padding_right);
  inherit_border (border_top);
  inherit_border (border_bottom);
  inherit_border (border_left);
  inherit_border (border_right);
  inherit_length(width);
  inherit_length(height);
  inherit_int (float_mode);
  inherit_int (clear);
  inherit_int (display);
  inherit_string(list_style_image_url);
  inherit_int(list_style_type);
  inherit_int(list_style_position);
  inherit_int(white_space);


