/*   E-scape
     Copyright (C) 1997 Free Software Foundation, Inc.
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <config.h>
#include "noxt.h"
#include "libnet.h"
#include <zlib.h>
#include "libit/string.h"
#include <stdio.h>
#include "libit/malloc.h"

#define GZ_BUFFER_SIZE 65536

static void gz_header(struct E_scape_filter *filter, char *data,
	size_t data_size)
{
	/* FIXME this does nothing.  Maybe it should do something?  */
}

static void actually_deflate(struct E_scape_filter *filter, char *data,
	size_t data_size)
{
	z_stream *z = filter->z;
	char outbuf[GZ_BUFFER_SIZE];
	int status;

	if (!data) {
		filter->next->app_data(filter->next, 0, 0);
		free(filter->z);
		return;
	}

	z->next_in = data;
	z->avail_in = data_size;

	while (z->avail_in > 0)
	{
		z->next_out = outbuf;
		z->avail_out = GZ_BUFFER_SIZE;
		status = inflate (z, Z_PARTIAL_FLUSH);
		filter->next->app_data(filter->next, outbuf,
			GZ_BUFFER_SIZE - z->avail_out);
		if (status == Z_STREAM_END)
		{
			inflateEnd(z);
			filter->app_data = gz_header;
			/* The following line causes cleanup */
			actually_deflate(filter, 0, 0);
			return;
		}
	}
}

void _E_scape_net_deflate_filter(struct E_scape_filter *filter, char *data,
	size_t data_size)
{
	z_stream *z;
	int status;

	z = malloc(sizeof(z_stream));
	filter->z = z;
	z->zalloc = Z_NULL;
	z->zfree = Z_NULL;
	z->opaque = Z_NULL;
	z->adler = 0;
	z->next_out = NULL;
	status = inflateInit(z);
	filter->app_data = actually_deflate;
	actually_deflate(filter, data, data_size);
}
