/*   E-scape
     Copyright (C) 1997 Free Software Foundation, Inc.
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <config.h>

#include <X11/Xatom.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/StripChart.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Dialog.h>

#include <locale.h>
#include <libintl.h>
#define _(String) gettext(String)
#define N_(String) gettext_noop(String)

#include <version.h>

#include <stdio.h>
#include "libit/unistd.h"
#include <sys/types.h>
#include "libtext.h"
#include "Net.h"

char *program_name;

extern String fallback_resources[];
extern int fallback_resource_intl_count;

static XtAppContext app;
static Widget top;

static Widget board;
static Widget back;
static Widget forward;
static Widget home;
static Widget stop;
static Widget reload;
static Widget quit;
static Widget graph;
static Widget net;
static Widget status;
static Widget bye;
static Widget byebye;
static Widget yes;
static Widget no;

int bytes_transfered;

/* These prototypes were removed from Net.h so that they can be
   Widget here and NetWidget elsewhere.  */
void NetForward(Widget self, Widget self2, XtPointer call_data);
void NetBack(Widget self, Widget self2, XtPointer call_data);
void NetHome(Widget self, Widget self2, XtPointer call_data);
void NetReload(Widget self, Widget self2, XtPointer call_data);
void NetStop(Widget self, Widget self2, XtPointer call_data);
void NetGoto(Widget self, char *URL, void *post_data, size_t post_count);


void SetToOne(Widget w, XtPointer closure, XtPointer call_data)
{
	int *i = closure;

	*i = 1;
}

void Die(Widget w, XtPointer closure, XtPointer call_data)
{
	exit(0);
}

static XtResource res[] = {
	{"homepage", "Url", XtRString, sizeof(String),
		0, XtRString, "http://www.gnu.ai.mit.edu"}
};

static void EntryCB(Widget w, XtPointer trash, XtPointer call_data)
{
	NetGoto(net, call_data, 0, 0);
};

static void GotoCB(Widget w, XtPointer trash, XtPointer call_data)
{
	char *tmp, *s;
	struct history_struct *h;
	int i, j;

#if 0
	XtVaSetValues(status, XtNlabel, call_data, NULL);
#if 0
	XtVaSetValues(entry, XtNtext, call_data, NULL);
#endif
	history_add(call_data);

	s = _("Back\nForward\nHome\n-----\n");
	tmp = strdup(s);
	h = history;
	while (h->back)
		h = h->back;
	while (h) {
		i = strlen(tmp);
		j = strlen(h->title);
		tmp = XtRealloc(tmp, i + j + 2);
		strcpy(tmp + i, h->title);
		tmp[i + j] = '\n';
		tmp[i + j + 1] = '\0';
		h = h->next;
	}
	/* FIXME reinstall this when its fixed */
#if 0
	XtVaSetValues(go, XtNmenu, tmp, NULL);
#endif
	/* FIXME: Am I supposed to free this value here or does it need to
	 * stick around?
	 */
	/* XtFree(tmp); */
#endif
}

#if 0
/* FIXME rewrite this */
/* Note that some of the following code may be strikingly similar to the
 * FChooserT program that demostrates this widget's cababilities.
 */
static void OpenOKCB(Widget w, XtPointer trash, XtPointer trash2)
{
	Arg args[1];
	char *dir, *file, *url;
	int dirl, filel;

	XtSetArg(args[0], XtNcurrentDirectory, &dir);
	XtGetValues(open_chooser, args, 1);
	XtSetArg(args[0], XtNcurrentFile, &file);
	XtGetValues(open_chooser, args, 1);

	if ((!dir) || (!*dir) || (!file) || (!*file)) return;
	dirl = strlen(dir);
	filel = strlen(file);
	url = XtMalloc(filel + dirl + 18);
	strcpy(url, "file://localhost");
	strcpy(url + 16, dir);
	url[16 + dirl] = '/';
	strcpy(url + 17 + dirl, file);

	NetGoto(net, url, 0, 0, 0);

	XtPopdown(open_shell);
}

static void OpenCancelCB(Widget w, XtPointer trash, XtPointer trash2)
{
	XtPopdown(open_shell);
}
#endif

static void GoCB(Widget w, XtPointer trash, XtPointer call_data)
{
#if 0
	XfwfTextMenuData *data = (void *) call_data;
	int n;

	n = data->n - 4;
	while (history->back)
		history = history->back;
	while (history->next && data->n)
		(history = history->next), data->n--;
	history_goto();
#endif
}

static void TitleCB(Widget w, XtPointer trash, XtPointer call_data)
{
	XtVaSetValues(top, XtNtitle, call_data, NULL);
}		

static void InfoCB(Widget w, XtPointer trash, XtPointer call_data)
{
	XtVaSetValues(status, XtNlabel, call_data, NULL);
}

static void GraphCB(Widget w, XtPointer trash, XtPointer call_data)
{
	double *d = call_data;

	*d = bytes_transfered;
	bytes_transfered = 0;
}

#if 0
FIXME
#if HAVE_LIBDND
void dnd_handler(Widget w, void *trash, XEvent *event, Boolean *trash2)
{
	int dnd_type, size;
	char *data, *tmp;

	dnd_type = DndDataType(event);
	switch (dnd_type) {
		case DndFile:
		case DndDir:
			DndGetData(&data, &size);
			tmp = XtMalloc(sizeof(data) + 17);
			strcpy(tmp, "file://localhost");
			strcpy(tmp + 16, data);
			history_add(tmp);
			history_goto();
			XtFree(tmp);
	}
}
#endif
#endif

/* What you tell someone when you want them to visit you. :-) */
static int stop_bye;

void create_bye(void)
{
	bye = XtVaCreatePopupShell("bye", transientShellWidgetClass,
		top, 0);
	byebye = XtVaCreateManagedWidget("byebye", dialogWidgetClass,
		bye, 0);
	yes = XtVaCreateManagedWidget("yes", commandWidgetClass, byebye, 0);
	XtAddCallback(yes, XtNcallback, Die, 0);
	no = XtVaCreateManagedWidget("no", commandWidgetClass, byebye, 0);
	XtAddCallback (no, XtNcallback, SetToOne, &stop_bye);
}

void modal_bye(Widget w, XtPointer trash, XtPointer more_garbage)
{
	if (!bye)
		create_bye();

	stop_bye = 0;

	XtPopup(bye, XtGrabExclusive);
	while (!stop_bye)
		XtAppProcessEvent(app, XtIMXEvent | XtIMTimer);

	XtPopdown(bye);
}

int main(int argc, char *argv[])
{

	int i;
	char *start_url;

	program_name = argv[0];

	setlocale(LC_ALL, "");
	bindtextdomain(PACKAGE, LOCALEDIR);
	textdomain(PACKAGE);

	for (i = 0; i < fallback_resource_intl_count; i++)
		fallback_resources[i] = _(fallback_resources[i]);

#if HAVE_XTVAOPENAPPLICATION
	top = XtVaOpenApplication(&app, "E-scape", NULL, 0, &argc, argv,
		fallback_resources, applicationShellWidgetClass, NULL);
#else
	top = XtVaAppInitialize(&app, "E-scape", NULL, 0, &argc, argv,
		fallback_resources, NULL);
#endif

	if (argc == 1) {
	  XtGetApplicationResources(top, &start_url, res, 1, 0, 0);
	} else {
	  start_url = argv[1];
	  if (argc != 2)
	    fprintf (stderr, _("Ignoring extra parameters.\n"));
	}

	board = XtVaCreateManagedWidget("board", formWidgetClass, top, 0);
	back = XtVaCreateManagedWidget("back", commandWidgetClass, board, 0);
	forward = XtVaCreateManagedWidget("forward", commandWidgetClass,
		board, 0);
	home = XtVaCreateManagedWidget("home", commandWidgetClass, board, 0);
	stop = XtVaCreateManagedWidget("stop", commandWidgetClass, board, 0);
	reload = XtVaCreateManagedWidget("reload", commandWidgetClass,
		board, 0);
	quit = XtVaCreateManagedWidget("quit", commandWidgetClass, board, 0);
	graph = XtVaCreateManagedWidget("graph", stripChartWidgetClass,
		board, 0);
	net = XtVaCreateManagedWidget("net", netWidgetClass, board, 0);
	status = XtVaCreateManagedWidget("status", labelWidgetClass, board, 0);

	XtAddCallback(net, XtNactivate, GotoCB, 0);
	XtAddCallback(net, XtNinfo, InfoCB, 0);
	XtAddCallback(net, XtNtitle, TitleCB, 0);

#if 0
	/* FIXME: this callback doesn't seem to exist */
	XtAddCallback(net, XtNgetValue, GraphCB, 0);
#endif

	XtAddCallback(back, XtNcallback, NetBack, net);
	XtAddCallback(forward, XtNcallback, NetForward, net);
	XtAddCallback(home, XtNcallback, NetHome, net);
	XtAddCallback(stop, XtNcallback, NetStop, net);
	XtAddCallback(reload, XtNcallback, NetReload, net);
	XtAddCallback(quit, XtNcallback, modal_bye, bye);

	E_scape_ident_init();
	E_scape_zombie_init ();

	XtRealizeWidget(top);

	NetGoto(net, start_url, 0, 0);

	XtAppMainLoop(app);

	return(1);
}
