/*   E-scape
     Copyright (C) 1997 Free Software Foundation, Inc.
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <config.h>
#include "noxt.h"
#include "libnet.h"
#include <sys/types.h>
#include "libit/unistd.h"
#include "libit/malloc.h"

struct E_scape_filter *_E_scape_new_filter(struct net_connection *net)
{
	struct E_scape_filter *tmp;

	tmp = malloc(sizeof(struct E_scape_filter));

	tmp->s = 0;
	tmp->data = 0;
	tmp->data_size = 0;
	tmp->stdin_fd = tmp->stdout_fd = tmp->stderr_fd = -1;
	tmp->stdout_id = tmp->stderr_id = 0;
	tmp->net = net;
	tmp->app_data = _E_scape_net_ident;
	tmp->next = 0;

	return tmp;
}

/* FIXME this copies the data even when it can just compare it then pass it
 * down. */
/* FIXME need to accept zeros for params */
void _E_scape_net_ident(struct E_scape_filter *filter, char *buf, size_t count)
{
	struct type_info *type;
	void *data;
	size_t data_size;
	char *mime;

	if (buf) {
		if (filter->data) {
			filter->data = realloc(filter->data, filter->data_size + count);
			memcpy(filter->data + filter->data_size, buf, count);
			filter->data_size += count;
		} else {
			filter->data = malloc(count);
			memcpy(filter->data, buf, count);
			filter->data_size = count;
		}
	}

	/* FIXME is this a good size? */
	/* FIXME supply file extension */
	if ((filter->data_size > 256) || (count == 0)) {
		/* FIXME a linked list would be cleaner here */
		mime = 0;
		if (filter->net->mime_encoding) {
			if (filter->net->filter == filter) {
				mime = filter->net->mime_encoding;
			} else if (filter->net->filter->next == filter) {
				mime = filter->net->mime_type;
			}
		} else if (filter->net->filter == filter) {
			if (filter->net->filter == filter) {
				mime = filter->net->mime_type;
			}
		}
		if (mime == 0)
			mime = "";
		type = E_scape_ident_find_match(mime, "",
			filter->data, filter->data_size);
		filter->s = type->s;
		if (type->app_data) {
			filter->app_data = type->app_data;
			filter->next = _E_scape_new_filter(filter->net);
		} else {
			filter->app_data = filter->net->out_data;
		}
		data = filter->data;
		data_size = filter->data_size;
		filter->data = 0;
		filter->data_size = 0;
		filter->app_data(filter, data, data_size);
		free(data);
		if (!buf)
			filter->app_data(filter, 0, 0);
	}
}
