/* Generated automagically by fsmbuild 0.7; manual editing is strongly
   discouraged.  */

#line 2 "gzip.fsm"
/*   E-scape
     Copyright (C) 1997 Free Software Foundation, Inc.
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */


#include <fsm.h>
#define MAGIC_NUM 0
#define METHOD 2
#define FLAGS 3
#define TRASH 4
#define EXTRA_FIELD 10
#define EXTRA_DATA 12
#define ORIG_NAME 13
#define COMMENT 14
#define HEAD_CRC 15
#define DATA 17
#define CRC 18
#line 21 "gzip.fsm"
#include "noxt.h"
#include <zlib.h>
#include <stdio.h>
#include "libnet.h"
#include "libit/string.h"
#include "libit/malloc.h"

#define X_ASCII_FLAG   0x01 /* bit 0 set: file probably ascii text */
#define X_HEAD_CRC     0x02 /* bit 1 set: header CRC present */
#define X_EXTRA_FIELD  0x04 /* bit 2 set: extra field present */
#define X_ORIG_NAME    0x08 /* bit 3 set: original file name present */
#define X_COMMENT      0x10 /* bit 4 set: file comment present */
#define X_RESERVED     0xE0 /* bits 5..7: reserved */
#define GZ_BUFFER_SIZE 65536



static void gunzip_cleanup(struct E_scape_filter *filter)
{
	filter->next->app_data(filter->next, 0, 0);
	free(filter->z);
	fsm_free_environment(filter->m);
}

static void gz_header(struct E_scape_filter *x, char *data, size_t data_size);

void _E_scape_net_gunzip_filter(struct E_scape_filter *filter, char *data,
        size_t data_size)
{
	z_stream *z;

	z = malloc(sizeof(z_stream));
	filter->z = z;
	z->zalloc = Z_NULL;
	z->zfree = Z_NULL;
	z->opaque = Z_NULL;
	z->adler = 0;
	filter->m = malloc(sizeof(struct fsm_environment));
	fsm_clear_environment(filter->m);
	filter->app_data = gz_header;
	gz_header(filter, data, data_size);
}


static void actually_decompress(struct E_scape_filter *filter, char *data,
	size_t data_size)
{
	char outbuf[GZ_BUFFER_SIZE];
	int status;

	z_stream *z = filter->z;
	z->next_in = data;
	z->avail_in = data_size;

	if (!data) {
		gunzip_cleanup(filter);
		return;
	}

	while (z->avail_in > 0)
	{
		z->next_out = outbuf;
		z->avail_out = GZ_BUFFER_SIZE;
		status = inflate (z, Z_PARTIAL_FLUSH);
		filter->next->app_data(filter->next, outbuf,
			GZ_BUFFER_SIZE - z->avail_out);
		if (status == Z_STREAM_END)
		{
			inflateEnd(z);
			filter->app_data = gz_header;
			gz_header(filter, z->next_in, z->avail_in);
			return;
		}
	}
}



#line 100 "gzip.fsm"
static void gz_header(struct E_scape_filter *x, char *data, size_t data_size)
{
	int status;
	struct fsm_environment *m = x->m;

	if (!data) {
		gunzip_cleanup(x);
		return;
	}
while (data_size > 0) {
switch (m->state) {
#line 110 "gzip.fsm"
case 0:
#line 110 "gzip.fsm"
m->state = 1;
break;
#line 110 "gzip.fsm"
case 1:
#line 110 "gzip.fsm"
m->state = 2;
break;
#line 111 "gzip.fsm"
case 2:
#line 111 "gzip.fsm"
x->method = 0;
#line 111 "gzip.fsm"
x->method += (*data) << 0;
#line 111 "gzip.fsm"
m->state = 3;
break;
#line 112 "gzip.fsm"
case 3:
#line 112 "gzip.fsm"
x->flags = 0;
#line 112 "gzip.fsm"
x->flags += (*data) << 0;
#line 112 "gzip.fsm"
m->state = 4;
	fsm_push_state(m, DATA);
	if (x->flags & X_HEAD_CRC)
		fsm_push_state(m, HEAD_CRC);
	if (x->flags & X_COMMENT)
		fsm_push_state(m, COMMENT);
	if (x->flags & X_ORIG_NAME)
		fsm_push_state(m, ORIG_NAME);
	if (x->flags & X_EXTRA_FIELD)
		fsm_push_state(m, EXTRA_FIELD);
break;
#line 123 "gzip.fsm"
case 4:
#line 123 "gzip.fsm"
m->state = 5;
break;
#line 123 "gzip.fsm"
case 5:
#line 123 "gzip.fsm"
m->state = 6;
break;
#line 123 "gzip.fsm"
case 6:
#line 123 "gzip.fsm"
m->state = 7;
break;
#line 123 "gzip.fsm"
case 7:
#line 123 "gzip.fsm"
m->state = 8;
break;
#line 123 "gzip.fsm"
case 8:
#line 123 "gzip.fsm"
m->state = 9;
break;
#line 123 "gzip.fsm"
case 9:
#line 123 "gzip.fsm"
m->state = fsm_pop_state(m);
break;
#line 124 "gzip.fsm"
case 10:
#line 124 "gzip.fsm"
x->len = 0;
#line 124 "gzip.fsm"
x->len += (*data) << 8;
#line 124 "gzip.fsm"
m->state = 11;
break;
#line 124 "gzip.fsm"
case 11:
#line 124 "gzip.fsm"
x->len += (*data) << 0;
#line 124 "gzip.fsm"
m->state = 12;
break;
#line 125 "gzip.fsm"
case 12:
#line 125 "gzip.fsm"
if (!(x->len)) {
#line 125 "gzip.fsm"
m->state = fsm_pop_state(m);
}
	x->len--;
break;
#line 128 "gzip.fsm"
case 13:
#line 128 "gzip.fsm"
if (!(*data)) {
#line 128 "gzip.fsm"
m->state = fsm_pop_state(m);
}
break;
#line 129 "gzip.fsm"
case 14:
#line 129 "gzip.fsm"
if (!(*data)) {
#line 129 "gzip.fsm"
m->state = fsm_pop_state(m);
}
break;
#line 130 "gzip.fsm"
case 15:
#line 130 "gzip.fsm"
m->state = 16;
break;
#line 130 "gzip.fsm"
case 16:
#line 130 "gzip.fsm"
m->state = fsm_pop_state(m);
break;
#line 131 "gzip.fsm"
case 17:
#line 131 "gzip.fsm"
m->state = CRC;
	/*	FIXME: This is ugly in that it relies on the count being
		updated after it is called.  Perhaps I should document
		that fsmbuild behaviour so I don't have to worry about it. */
	x->app_data = actually_decompress;
	((z_stream *)(x->z))->next_out = NULL;
	status = inflateInit2(x->z, -MAX_WBITS);
	actually_decompress(x, data, data_size);
	return;
break;
#line 141 "gzip.fsm"
case 18:
#line 141 "gzip.fsm"
m->state = 19;
break;
#line 141 "gzip.fsm"
case 19:
#line 141 "gzip.fsm"
m->state = 20;
break;
#line 141 "gzip.fsm"
case 20:
#line 141 "gzip.fsm"
m->state = 21;
break;
#line 141 "gzip.fsm"
case 21:
#line 141 "gzip.fsm"
m->state = 22;
break;
#line 141 "gzip.fsm"
case 22:
#line 141 "gzip.fsm"
m->state = 23;
break;
#line 141 "gzip.fsm"
case 23:
#line 141 "gzip.fsm"
m->state = 24;
break;
#line 141 "gzip.fsm"
case 24:
#line 141 "gzip.fsm"
m->state = 25;
break;
#line 141 "gzip.fsm"
case 25:
#line 141 "gzip.fsm"
m->state = MAGIC_NUM;
break;
}
data++, data_size--;
}
}
