/* Generated automagically by fsmbuild 0.7; manual editing is strongly
   discouraged.  */

#line 2 "html.fsm"
/*   E-scape
     Copyright (C) 1997 Free Software Foundation, Inc.
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */


#include <fsm.h>
#define TEXT 0
#define TAG 1
#define TAG_NAME 2
#define TAG_LWS 3
#define TAG_ATTR 4
#define TAG_EQUAL 5
#define TAG_VALUE 6
#define TAG_ESCAPE 7
#define TAG_END 8
#define TAG_CLOSE 9
#define TAG_CLOSE_END 10
#define SPECIAL 11
#define PLAINTEXT 12
#define RETURN 13
#line 21 "html.fsm"
#include "libtext.h"
#include "libit/string.h"
#include "libit/malloc.h"



inline static struct tag_attribute *new_tag_attribute(void)
{
	struct tag_attribute *x;

	x = malloc(sizeof(struct tag_attribute));

	x->name = 0;
	x->data = 0;
	x->next = 0;

	return x;
}


inline static struct text_chunk *new_text_chunk(void)
{
	struct text_chunk *t;

	t = malloc(sizeof(struct text_chunk));
	t->next = t->previous = t->parent = t->child = 0;
	t->tag_name = 0;
	t->attr = 0;
	t->data = 0;
	t->data_size = 0;
	t->properties = t->first_line_properties = t->first_letter_properties
		= t->marker_properties = 0;
	t->widget = 0;

	return t;
}

inline static void sized_string_append_char(char **s, size_t *count, char c)
{
	(*count)++;
	*s = realloc(*s, *count);
	(*s)[*count] = c;
}

inline static void find_tail(struct text_chunk **x)
{
	while (((*x)->next) || ((*x)->child)) {
		while ((*x)->next)
			*x = (*x)->next;
		while ((*x)->child)
			*x = (*x)->child;
	}
}

inline static void append_tag_attr(struct tag_attribute **dest,
	struct tag_attribute *src)
{
	struct tag_attribute *tail;
	if (*dest) {
		tail = *dest;
		while (tail->next)
			tail = tail->next;
		tail->next = src; 
	} else {
		*dest = src;
	}
}


inline static void link_child_chunk(struct text_chunk **t,
	struct text_chunk *p)
{
	p->parent = *t;
	(*t)->child = p;
	*t = p;
}

inline static void insert_new_tag_attribute(
	struct tag_attribute **x)
{
	struct tag_attribute *p;

	p = new_tag_attribute();
	p->next = *x;
	*x = p;
}

inline static void link_next_chunk(struct text_chunk **t, struct text_chunk *p)
{
	p->previous = *t;
	(*t)->next = p;
	*t = p;
}

inline static void link_chunk(struct html_parser_state *x,
	struct text_chunk *p)
{
	if (x->current) {
		if (x->new_child_chunk) {
			link_child_chunk(&x->current, p);
		} else {
			link_next_chunk(&x->current, p);
		}
	} else {
		x->current = p;
	}
	x->new_child_chunk = 0;
	x->new_next_chunk = 0;
}

inline static void prepare_text_chunk(struct html_parser_state *x)
{
	if (x->current->tag_name) {
		link_chunk(x, new_text_chunk());
	}
}

inline static void add_text(struct html_parser_state *x)
{
	struct fsm_environment *m = x->m;

	if (m->string_count) {
		prepare_text_chunk(x);
		fsm_append_to_sized_string(m, &(x->current->data),
			&(x->current->data_size));
		fsm_clear_string(m);
	}
}

inline static void tag_start(struct html_parser_state *x)
{
	if (x->tag_start)
		x->tag_start(x);
}

inline static void tag_finish(struct html_parser_state *x)
{
	if (x->tag_finish)
		x->tag_finish(x);
}

inline static void line_finish(struct html_parser_state *x)
{
	if (x->line_finish)
		x->line_finish(x);
}

/*	Calls tag_finish for all the finished chunks, including
	bottom, but not top.  Leaves x->current == top  */
inline static void nested_tag_finish(struct html_parser_state *x,
	struct text_chunk *top, struct text_chunk *bottom)
{
	while (bottom != top) {
		x->current = bottom;
		tag_finish(x);
		bottom = bottom->parent;
	}
}

struct html_parser_state *new_html_parser_state(void)
{
	struct html_parser_state *x;

	x = malloc(sizeof(struct html_parser_state));

	x->html = 0;
	x->current = 0;
	x->future = 0;

	x->tag_attr = 0;

	x->m = fsm_new_environment();

	x->new_child_chunk = 1;
	x->new_next_chunk = 0;

	x->tag_start = 0;
	x->tag_finish = 0;
	x->line_finish = 0;

	return x;
}


#line 206 "html.fsm"
void parse_html(struct html_parser_state *x, char *data, size_t data_size)
{
	struct fsm_environment *m = x->m;
	struct text_chunk *future;

	if (!data) {
		/* FIXME call an appropriate callback */
		fsm_free_environment(x->m);
		free(x);
		return;
	}
while (data_size > 0) {
switch (m->state) {
#line 218 "html.fsm"
case 0:
switch (*data) {
#line 219 "html.fsm"
case '<':
#line 219 "html.fsm"
m->state = TAG;
	add_text(x);
break;
#line 222 "html.fsm"
case '&':
#line 222 "html.fsm"
m->state = SPECIAL;
	add_text(x);
break;
#line 225 "html.fsm"
default:
#line 225 "html.fsm"
fsm_append_char (m, (*data));
#line 225 "html.fsm"
m->state = TEXT;
break;
}
break;
#line 228 "html.fsm"
case 1:
switch (*data) {
#line 229 "html.fsm"
case ' ':
#line 229 "html.fsm"
case  '\t':
#line 229 "html.fsm"
case  '\n':
#line 229 "html.fsm"
case  '\r':
#line 229 "html.fsm"
m->state = TAG;
break;
#line 230 "html.fsm"
case '/':
#line 230 "html.fsm"
m->state = TAG_CLOSE;
break;
#line 231 "html.fsm"
default:
#line 231 "html.fsm"
m->state = TAG_NAME;
#line 231 "html.fsm"
continue;
break;
}
break;
#line 233 "html.fsm"
case 2:
switch (*data) {
#line 234 "html.fsm"
case 'A':
#line 234 "html.fsm"
case 'B':
#line 234 "html.fsm"
case 'C':
#line 234 "html.fsm"
case 'D':
#line 234 "html.fsm"
case 'E':
#line 234 "html.fsm"
case 'F':
#line 234 "html.fsm"
case 'G':
#line 234 "html.fsm"
case 'H':
#line 234 "html.fsm"
case 'I':
#line 234 "html.fsm"
case 'J':
#line 234 "html.fsm"
case 'K':
#line 234 "html.fsm"
case 'L':
#line 234 "html.fsm"
case 'M':
#line 234 "html.fsm"
case 'N':
#line 234 "html.fsm"
case 'O':
#line 234 "html.fsm"
case 'P':
#line 234 "html.fsm"
case 'Q':
#line 234 "html.fsm"
case 'R':
#line 234 "html.fsm"
case 'S':
#line 234 "html.fsm"
case 'T':
#line 234 "html.fsm"
case 'U':
#line 234 "html.fsm"
case 'V':
#line 234 "html.fsm"
case 'W':
#line 234 "html.fsm"
case 'X':
#line 234 "html.fsm"
case 'Y':
#line 234 "html.fsm"
case 'Z':
#line 234 "html.fsm"
case 'a':
#line 234 "html.fsm"
case 'b':
#line 234 "html.fsm"
case 'c':
#line 234 "html.fsm"
case 'd':
#line 234 "html.fsm"
case 'e':
#line 234 "html.fsm"
case 'f':
#line 234 "html.fsm"
case 'g':
#line 234 "html.fsm"
case 'h':
#line 234 "html.fsm"
case 'i':
#line 234 "html.fsm"
case 'j':
#line 234 "html.fsm"
case 'k':
#line 234 "html.fsm"
case 'l':
#line 234 "html.fsm"
case 'm':
#line 234 "html.fsm"
case 'n':
#line 234 "html.fsm"
case 'o':
#line 234 "html.fsm"
case 'p':
#line 234 "html.fsm"
case 'q':
#line 234 "html.fsm"
case 'r':
#line 234 "html.fsm"
case 's':
#line 234 "html.fsm"
case 't':
#line 234 "html.fsm"
case 'u':
#line 234 "html.fsm"
case 'v':
#line 234 "html.fsm"
case 'w':
#line 234 "html.fsm"
case 'x':
#line 234 "html.fsm"
case 'y':
#line 234 "html.fsm"
case 'z':
#line 234 "html.fsm"
case '0':
#line 234 "html.fsm"
case '1':
#line 234 "html.fsm"
case '2':
#line 234 "html.fsm"
case '3':
#line 234 "html.fsm"
case '4':
#line 234 "html.fsm"
case '5':
#line 234 "html.fsm"
case '6':
#line 234 "html.fsm"
case '7':
#line 234 "html.fsm"
case '8':
#line 234 "html.fsm"
case '9':
#line 234 "html.fsm"
case '_':
#line 234 "html.fsm"
fsm_append_char (m, (*data));
#line 234 "html.fsm"
m->state = TAG_NAME;
break;
#line 235 "html.fsm"
default:
#line 235 "html.fsm"
m->state = TAG_LWS;
	x->future = new_text_chunk();
	fsm_append_to_null_string(m, &(x->future->tag_name));
	fsm_clear_string(m);
	continue;
break;
}
break;
#line 242 "html.fsm"
case 3:
switch (*data) {
#line 243 "html.fsm"
case ' ':
#line 243 "html.fsm"
case  '\t':
#line 243 "html.fsm"
case  '\n':
#line 243 "html.fsm"
case  '\r':
#line 243 "html.fsm"
m->state = TAG;
break;
#line 244 "html.fsm"
case '>':
#line 244 "html.fsm"
m->state = TAG_END;
#line 244 "html.fsm"
continue;
break;
#line 245 "html.fsm"
default:
#line 245 "html.fsm"
m->state = TAG_ATTR;
#line 245 "html.fsm"
continue;
break;
}
break;
#line 247 "html.fsm"
case 4:
switch (*data) {
#line 248 "html.fsm"
case 'A':
#line 248 "html.fsm"
case 'B':
#line 248 "html.fsm"
case 'C':
#line 248 "html.fsm"
case 'D':
#line 248 "html.fsm"
case 'E':
#line 248 "html.fsm"
case 'F':
#line 248 "html.fsm"
case 'G':
#line 248 "html.fsm"
case 'H':
#line 248 "html.fsm"
case 'I':
#line 248 "html.fsm"
case 'J':
#line 248 "html.fsm"
case 'K':
#line 248 "html.fsm"
case 'L':
#line 248 "html.fsm"
case 'M':
#line 248 "html.fsm"
case 'N':
#line 248 "html.fsm"
case 'O':
#line 248 "html.fsm"
case 'P':
#line 248 "html.fsm"
case 'Q':
#line 248 "html.fsm"
case 'R':
#line 248 "html.fsm"
case 'S':
#line 248 "html.fsm"
case 'T':
#line 248 "html.fsm"
case 'U':
#line 248 "html.fsm"
case 'V':
#line 248 "html.fsm"
case 'W':
#line 248 "html.fsm"
case 'X':
#line 248 "html.fsm"
case 'Y':
#line 248 "html.fsm"
case 'Z':
#line 248 "html.fsm"
case 'a':
#line 248 "html.fsm"
case 'b':
#line 248 "html.fsm"
case 'c':
#line 248 "html.fsm"
case 'd':
#line 248 "html.fsm"
case 'e':
#line 248 "html.fsm"
case 'f':
#line 248 "html.fsm"
case 'g':
#line 248 "html.fsm"
case 'h':
#line 248 "html.fsm"
case 'i':
#line 248 "html.fsm"
case 'j':
#line 248 "html.fsm"
case 'k':
#line 248 "html.fsm"
case 'l':
#line 248 "html.fsm"
case 'm':
#line 248 "html.fsm"
case 'n':
#line 248 "html.fsm"
case 'o':
#line 248 "html.fsm"
case 'p':
#line 248 "html.fsm"
case 'q':
#line 248 "html.fsm"
case 'r':
#line 248 "html.fsm"
case 's':
#line 248 "html.fsm"
case 't':
#line 248 "html.fsm"
case 'u':
#line 248 "html.fsm"
case 'v':
#line 248 "html.fsm"
case 'w':
#line 248 "html.fsm"
case 'x':
#line 248 "html.fsm"
case 'y':
#line 248 "html.fsm"
case 'z':
#line 248 "html.fsm"
case '0':
#line 248 "html.fsm"
case '1':
#line 248 "html.fsm"
case '2':
#line 248 "html.fsm"
case '3':
#line 248 "html.fsm"
case '4':
#line 248 "html.fsm"
case '5':
#line 248 "html.fsm"
case '6':
#line 248 "html.fsm"
case '7':
#line 248 "html.fsm"
case '8':
#line 248 "html.fsm"
case '9':
#line 248 "html.fsm"
case '_':
#line 248 "html.fsm"
fsm_append_char (m, (*data));
#line 248 "html.fsm"
m->state = TAG_ATTR;
break;
#line 249 "html.fsm"
default:
#line 249 "html.fsm"
m->state = TAG_EQUAL;
	insert_new_tag_attribute(&x->future->attr);
	fsm_append_to_null_string(m, &(x->future->attr->name));
	fsm_clear_string(m);
	continue;
break;
}
break;
#line 256 "html.fsm"
case 5:
switch (*data) {
#line 257 "html.fsm"
case '>':
#line 257 "html.fsm"
m->state = TAG_END;
#line 257 "html.fsm"
continue;
break;
#line 258 "html.fsm"
case '=':
#line 258 "html.fsm"
m->state = TAG_VALUE;
break;
#line 259 "html.fsm"
default:
#line 259 "html.fsm"
m->state = TAG_EQUAL;
break;
}
break;
#line 261 "html.fsm"
case 6:
switch (*data) {
#line 262 "html.fsm"
case '\\':
#line 262 "html.fsm"
m->state = TAG_ESCAPE;
break;
#line 263 "html.fsm"
case '"':
#line 263 "html.fsm"
m->state = TAG_LWS;
break;
#line 264 "html.fsm"
default:
#line 264 "html.fsm"
fsm_append_char (m, (*data));
#line 264 "html.fsm"
m->state = TAG_VALUE;
break;
}
break;
#line 266 "html.fsm"
case 7:
switch (*data) {
#line 267 "html.fsm"
default:
#line 267 "html.fsm"
fsm_append_char (m, (*data));
#line 267 "html.fsm"
m->state = TAG_VALUE;
break;
}
break;
#line 269 "html.fsm"
case 8:
switch (*data) {
#line 270 "html.fsm"
default:
#line 270 "html.fsm"
m->state = RETURN;
	if (m->string_count) {
		fsm_append_to_null_string(m, &(x->future->attr->data));
		fsm_clear_string(m);
	}

	if ((!strcasecmp(x->future->tag_name, "p"))
		&& (x->current->data)
		&& (strcasecmp(x->current->parent->tag_name, "p"))) {

			x->future->child = x->current;
			x->future->parent = x->current->parent;
			x->future->next = x->current->next;
			x->future->previous = x->current->previous;

			if (x->current->previous)
				x->current->previous->next = x->future;
			/* x->current->next == 0 always */
			if (x->current->parent->child == x->current)
				x->current->parent->child = x->future;
			/* text chunks never have children */

			x->current->next = x->current->previous = 0;
			x->current->parent = 0;

			x->current = x->future;

			/* FIXME set flags indicating change */

			fsm_push_state(m, TEXT);

			tag_start(x);

	} else if (!strcasecmp(x->future->tag_name, "plaintext")) {

		link_chunk(x, x->future);

		fsm_push_state(m, PLAINTEXT);

		tag_start(x);

	} else if (!strcasecmp(x->future->tag_name, "li")) {

		future = x->current;

		if (future->data)
			future = future->parent;

		while (future
			&& strcasecmp(x->future->tag_name, "li")
			&& strcasecmp(x->future->tag_name, "ul")
			&& strcasecmp(x->future->tag_name, "ol")) {

			future = future->parent;
		}

		if (!strcasecmp(x->future->tag_name, "li")) {

			nested_tag_finish(x, future, x->current);

			x->current = future;

			x->new_child_chunk = 0;
			x->new_next_chunk = 1;

		}

		link_chunk(x, x->future);

		tag_start(x);

	} else if ((!strcasecmp(x->future->tag_name, "dt"))
		|| (!strcasecmp(x->future->tag_name, "dd"))) {

		future = x->current;

		if (future->data)
			future = future->parent;

		while (future
			&& strcasecmp(x->future->tag_name, "dt")
			&& strcasecmp(x->future->tag_name, "dd")
			&& strcasecmp(x->future->tag_name, "dl")) {
			future = future->parent;
		}

		if ((!strcasecmp(x->future->tag_name, "dt"))
			|| (!strcasecmp(x->future->tag_name, "dd"))) {
			nested_tag_finish(x, future, x->current);

			x->current = future;
			x->new_child_chunk = 0;
			x->new_next_chunk = 1;
		}

		link_chunk(x, x->future);

		tag_start(x);

	} else if ((!strcasecmp(x->future->tag_name, "img"))
		|| (!strcasecmp(x->future->tag_name, "link"))
		|| (!strcasecmp(x->future->tag_name, "isindex"))
		|| (!strcasecmp(x->future->tag_name, "meta"))
		|| (!strcasecmp(x->future->tag_name, "hr"))
		|| (!strcasecmp(x->future->tag_name, "br"))
		|| (!strcasecmp(x->future->tag_name, "input"))
		|| (!strcasecmp(x->future->tag_name, "embed"))
		|| (!strcasecmp(x->future->tag_name, "bgsound"))) {

		link_chunk(x, x->future);
		tag_start(x);
		tag_finish(x);

		x->new_next_chunk = 1;

		fsm_push_state(m, TEXT);
	} else {

		link_chunk(x, x->future);

		tag_start(x);

		x->new_child_chunk = 1;

		fsm_push_state(m, TEXT);
	}
	continue;
break;
}
break;
#line 399 "html.fsm"
case 9:
switch (*data) {
#line 400 "html.fsm"
case 'A':
#line 400 "html.fsm"
case 'B':
#line 400 "html.fsm"
case 'C':
#line 400 "html.fsm"
case 'D':
#line 400 "html.fsm"
case 'E':
#line 400 "html.fsm"
case 'F':
#line 400 "html.fsm"
case 'G':
#line 400 "html.fsm"
case 'H':
#line 400 "html.fsm"
case 'I':
#line 400 "html.fsm"
case 'J':
#line 400 "html.fsm"
case 'K':
#line 400 "html.fsm"
case 'L':
#line 400 "html.fsm"
case 'M':
#line 400 "html.fsm"
case 'N':
#line 400 "html.fsm"
case 'O':
#line 400 "html.fsm"
case 'P':
#line 400 "html.fsm"
case 'Q':
#line 400 "html.fsm"
case 'R':
#line 400 "html.fsm"
case 'S':
#line 400 "html.fsm"
case 'T':
#line 400 "html.fsm"
case 'U':
#line 400 "html.fsm"
case 'V':
#line 400 "html.fsm"
case 'W':
#line 400 "html.fsm"
case 'X':
#line 400 "html.fsm"
case 'Y':
#line 400 "html.fsm"
case 'Z':
#line 400 "html.fsm"
case 'a':
#line 400 "html.fsm"
case 'b':
#line 400 "html.fsm"
case 'c':
#line 400 "html.fsm"
case 'd':
#line 400 "html.fsm"
case 'e':
#line 400 "html.fsm"
case 'f':
#line 400 "html.fsm"
case 'g':
#line 400 "html.fsm"
case 'h':
#line 400 "html.fsm"
case 'i':
#line 400 "html.fsm"
case 'j':
#line 400 "html.fsm"
case 'k':
#line 400 "html.fsm"
case 'l':
#line 400 "html.fsm"
case 'm':
#line 400 "html.fsm"
case 'n':
#line 400 "html.fsm"
case 'o':
#line 400 "html.fsm"
case 'p':
#line 400 "html.fsm"
case 'q':
#line 400 "html.fsm"
case 'r':
#line 400 "html.fsm"
case 's':
#line 400 "html.fsm"
case 't':
#line 400 "html.fsm"
case 'u':
#line 400 "html.fsm"
case 'v':
#line 400 "html.fsm"
case 'w':
#line 400 "html.fsm"
case 'x':
#line 400 "html.fsm"
case 'y':
#line 400 "html.fsm"
case 'z':
#line 400 "html.fsm"
case '0':
#line 400 "html.fsm"
case '1':
#line 400 "html.fsm"
case '2':
#line 400 "html.fsm"
case '3':
#line 400 "html.fsm"
case '4':
#line 400 "html.fsm"
case '5':
#line 400 "html.fsm"
case '6':
#line 400 "html.fsm"
case '7':
#line 400 "html.fsm"
case '8':
#line 400 "html.fsm"
case '9':
#line 400 "html.fsm"
case '_':
#line 400 "html.fsm"
fsm_append_char (m, (*data));
#line 400 "html.fsm"
m->state = TAG_CLOSE;
break;
#line 401 "html.fsm"
default:
#line 401 "html.fsm"
m->state = TAG_CLOSE_END;
#line 401 "html.fsm"
continue;
break;
}
break;
#line 404 "html.fsm"
case 10:
switch (*data) {
#line 405 "html.fsm"
case ' ':
#line 405 "html.fsm"
case  '\t':
#line 405 "html.fsm"
case  '\n':
#line 405 "html.fsm"
case  '\r':
#line 405 "html.fsm"
m->state = TAG_CLOSE_END;
break;
#line 406 "html.fsm"
case '>':
#line 406 "html.fsm"
m->state = TEXT;
	future = x->current;

	if (future->data)
		future = future->parent;

	if (m->string_size) {
		while (future && fsm_case_cmp(m, future->tag_name)) {
			future = future->parent;
		}
	}

	if (future) {
		nested_tag_finish(x, future, x->current);

		x->current = future;

		x->new_next_chunk = 1;
	}

	if (x->future)
		x->current = x->future;

	tag_finish(x);
break;
}
break;
#line 434 "html.fsm"
case 11:
switch (*data) {
#line 435 "html.fsm"
case 'A':
#line 435 "html.fsm"
case 'B':
#line 435 "html.fsm"
case 'C':
#line 435 "html.fsm"
case 'D':
#line 435 "html.fsm"
case 'E':
#line 435 "html.fsm"
case 'F':
#line 435 "html.fsm"
case 'G':
#line 435 "html.fsm"
case 'H':
#line 435 "html.fsm"
case 'I':
#line 435 "html.fsm"
case 'J':
#line 435 "html.fsm"
case 'K':
#line 435 "html.fsm"
case 'L':
#line 435 "html.fsm"
case 'M':
#line 435 "html.fsm"
case 'N':
#line 435 "html.fsm"
case 'O':
#line 435 "html.fsm"
case 'P':
#line 435 "html.fsm"
case 'Q':
#line 435 "html.fsm"
case 'R':
#line 435 "html.fsm"
case 'S':
#line 435 "html.fsm"
case 'T':
#line 435 "html.fsm"
case 'U':
#line 435 "html.fsm"
case 'V':
#line 435 "html.fsm"
case 'W':
#line 435 "html.fsm"
case 'X':
#line 435 "html.fsm"
case 'Y':
#line 435 "html.fsm"
case 'Z':
#line 435 "html.fsm"
case 'a':
#line 435 "html.fsm"
case 'b':
#line 435 "html.fsm"
case 'c':
#line 435 "html.fsm"
case 'd':
#line 435 "html.fsm"
case 'e':
#line 435 "html.fsm"
case 'f':
#line 435 "html.fsm"
case 'g':
#line 435 "html.fsm"
case 'h':
#line 435 "html.fsm"
case 'i':
#line 435 "html.fsm"
case 'j':
#line 435 "html.fsm"
case 'k':
#line 435 "html.fsm"
case 'l':
#line 435 "html.fsm"
case 'm':
#line 435 "html.fsm"
case 'n':
#line 435 "html.fsm"
case 'o':
#line 435 "html.fsm"
case 'p':
#line 435 "html.fsm"
case 'q':
#line 435 "html.fsm"
case 'r':
#line 435 "html.fsm"
case 's':
#line 435 "html.fsm"
case 't':
#line 435 "html.fsm"
case 'u':
#line 435 "html.fsm"
case 'v':
#line 435 "html.fsm"
case 'w':
#line 435 "html.fsm"
case 'x':
#line 435 "html.fsm"
case 'y':
#line 435 "html.fsm"
case 'z':
#line 435 "html.fsm"
case '0':
#line 435 "html.fsm"
case '1':
#line 435 "html.fsm"
case '2':
#line 435 "html.fsm"
case '3':
#line 435 "html.fsm"
case '4':
#line 435 "html.fsm"
case '5':
#line 435 "html.fsm"
case '6':
#line 435 "html.fsm"
case '7':
#line 435 "html.fsm"
case '8':
#line 435 "html.fsm"
case '9':
#line 435 "html.fsm"
case '_':
#line 435 "html.fsm"
fsm_append_char (m, (*data));
#line 435 "html.fsm"
m->state = SPECIAL;
break;
#line 436 "html.fsm"
default:
#line 436 "html.fsm"
m->state = TEXT;
	/*	Note that we allow a non-alphanumeric character to
		be eaten, so that the Right Thing can happen with
		&amp;  */
	/*	FIXME that probably still loses for &amp */
	/*	&shy; should be ignored; keep this in mind when
		you fix it.  */
	if (!fsm_case_cmp(m, "amp")) {
		sized_string_append_char(&(x->current->data),
			&(x->current->data_size), '&');
	} else if (!fsm_case_cmp(m, "lt")) {
		sized_string_append_char(&(x->current->data),
			&(x->current->data_size), '<');
	} else if (!fsm_case_cmp(m, "gt")) {
		sized_string_append_char(&(x->current->data),
			&(x->current->data_size), '>');
	} else {
		/* FIXME */
	}
	fsm_clear_string(m);
break;
}
break;
#line 459 "html.fsm"
case 12:
switch (*data) {
#line 460 "html.fsm"
case '\n':
#line 460 "html.fsm"
case  '\r':
#line 460 "html.fsm"
fsm_append_char (m, (*data));
#line 460 "html.fsm"
m->state = PLAINTEXT;
	line_finish(x);
break;
#line 463 "html.fsm"
default:
#line 463 "html.fsm"
fsm_append_char (m, (*data));
#line 463 "html.fsm"
m->state = PLAINTEXT;
break;
}
break;
#line 466 "html.fsm"
case 13:
#line 466 "html.fsm"
m->state = fsm_pop_state(m);
break;
}
data++, data_size--;
}
}
