/* Generated automagically by fsmbuild 0.7; manual editing is strongly
   discouraged.  */

#line 2 "legal.fsm"
/*   E-scape GIF89a/GIF87a format reader
     Copyright (C) 1997 Free Software Foundation, Inc.
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

/*	This file tries to handle displaying files whose first characters
	are 'GIF87a' or 'GIF89a'.  It's LEGAL, SEE?  (legal.c)  */


#include <fsm.h>
#define GIF87a_ID 0
#define LOGICAL_X 6
#define LOGICAL_Y 8
#define GLOBAL_PACKED 10
#define BACKGROUND 11
#define ASPECT 12
#define GLOBAL_PALATE 13
#define NEXT_CHUNK 14
#define EXTENSION 15
#define EXTENSION_COUNT 16
#define EXTENSION_DATA 17
#define IMAGE_LEFT 18
#define IMAGE_TOP 20
#define IMAGE_WIDTH 22
#define IMAGE_HEIGHT 24
#define IMAGE_PACKED 26
#define LOCAL_PALATE 27
#define CODE_SIZE 28
#define DATA_SIZE 29
#define DATA 30
#define DIE 31
#line 24 "legal.fsm"
#include "image.h"

/* This struct holds the state of the GIF parser completely. */
struct gif_state {
	/* These fields are extracted directly from various parts of
	 * the file.  Read The Fabulous Manual about the GIF format.
	 */
	unsigned char	global_packed, image_packed;
	unsigned char	background;
	unsigned char	aspect;

	/* I believe that palate is the global palate.  lpalate is
	 * the local palate.  The global palate gets copied to
	 * the local palate if there is no local palate for a given
	 * image.  I think.
	 */
	unsigned char	palate[256][3], lpalate[256][3];

	/* Something related to the unpatented decompression.
	 */
	unsigned char	code_size, start_code_size;

	/* Various measurements of the file size.  Probably x and y
	 * hold the current position, left top width height
	 * are extracted directly from the file.
	 */
	int		x, y, left, top, width, height;

	/* Some sort of counter of how many bytes are left in the
	 * current chunk.
	 */
	int		count;

	char		max_color;

	/* Decompression stuff?
	 */
	int		code_acc;
	int		code_bits;
	int		code_mask;
	int		code_max;
	int		code_old;
	unsigned char	clear_code;
	int		tablep[4096];
	unsigned char	tablec[4096];
	char		first_byte;
	char		pass;

	struct fsm_environment m;
};

static void parse_gif(struct image_struct *image, char *data, size_t data_size);
#line 77 "legal.fsm"

/* This function is called when an indivdual pixel has been decompressed.
 * It identifies a home for that pixel and puts it into the image
 */
inline static void output_pixel(struct image_struct *image, unsigned char c)
{
	struct gif_state *gif = image->private;
	int loop;

	for (loop = 0; loop < (gif->pass ? (16 >> gif->pass) : 1); loop++)
		image_put_pixel_rgb(image, gif->x, gif->y + loop,
			gif->lpalate[c][0],
			gif->lpalate[c][1], gif->lpalate[c][2], 255);
	gif->x++;
	if (gif->x >= (gif->left + gif->width)) {
		gif->x = gif->left;
		switch (gif->pass) {
			case 0:
				gif->y++;
				break;
			case 1:
			case 2:
				gif->y += 8;
				break;
			case 3:
				gif->y += 4;
				break;
			case 4:
				gif->y += 2;
				break;
		}
		if (gif->y >= (gif->top + gif->height)) {
			switch (gif->pass) {
				case 1:
					gif->y = gif->top + 4;
					gif->pass++;
					break;
				case 2:
					gif->y = gif->top + 2;
					gif->pass++;
					break;
				case 3:
					gif->y = gif->top + 1;
					gif->pass++;
					break;
			}
		}
	}
}

/* Recursive function that helps with decompression.
 */
inline static void output_code(struct image_struct *image, int c)
{
	struct gif_state *gif = image->private;

	if (c > gif->clear_code)
		output_code(image, gif->tablep[c]);

	output_pixel(image, gif->tablec[c]);
}

/* When we have gotten a code, which may or may not be 8 bits wide,
 * we call this function, and it figures out what to do.
 */
inline static void decompress_code(struct image_struct *image, int c)
{
	struct gif_state *gif = image->private;
	unsigned int tmp;

	if (c == gif->clear_code) {
		gif->code_max = (1 << gif->code_size) + 2;
		gif->code_size = gif->start_code_size;
		gif->code_mask = (2 << gif->code_size) - 1;
		gif->first_byte = 1;
	} else if (c == gif->clear_code + 1) {
		/* That's all folks... */
	} else if (gif->first_byte) {
		output_pixel(image, c);
		gif->code_old = c;
		gif->first_byte = 0;
	} else if (c < gif->code_max) {
		output_code(image, c);
		tmp = c;
		while (tmp > gif->clear_code)
			tmp = gif->tablep[tmp];
		gif->tablep[gif->code_max] = gif->code_old;
		gif->tablec[gif->code_max] = tmp;
		gif->code_max++;
		gif->code_old = c;
	} else if (c == gif->code_max) {
		tmp = gif->code_old;
		while (tmp > gif->clear_code)
			tmp = gif->tablep[tmp];
		gif->tablec[gif->code_max] = gif->tablec[tmp];
		gif->tablep[gif->code_max] = gif->code_old;
		gif->code_max++;
		output_code(image, c);
		gif->code_old = c;
	} else {
		/* Major problems, pretend everything is fine... */
	}
	if ((gif->code_max == (2 << gif->code_size)) && (gif->code_size < 12)) {
		gif->code_size++;
		gif->code_mask = (2 << gif->code_size) - 1;
	}
}

/* This function takes a byte and splits it into as many codes as possible,
 * and then calls the function immediately above to continue decompressing.
 */
inline static void unpack_byte(struct image_struct *image, unsigned char c)
{
	struct gif_state *gif = image->private;
	int old_code_size;

	gif->code_acc |= ((int)c) << gif->code_bits;
	gif->code_bits += 8;
	while (gif->code_bits > gif->code_size) {
		/* A warning to stupid people like nemo: decompress_code
		 * will modify gif->code_size.
		 */
		old_code_size = gif->code_size;
		decompress_code(image, gif->code_acc & gif->code_mask);
		gif->code_acc = gif->code_acc >> (old_code_size + 1);
		gif->code_bits -= old_code_size + 1;
	}
}




#line 210 "legal.fsm"
static void parse_gif(struct image_struct *image, char *data, size_t data_size)
{
	struct gif_state *x = image->private;
	struct fsm_environment *m = &(x->m);

while (data_size > 0) {
switch (m->state) {
#line 218 "legal.fsm"
case 0:
#line 218 "legal.fsm"
m->state = 1;
break;
#line 218 "legal.fsm"
case 1:
#line 218 "legal.fsm"
m->state = 2;
break;
#line 218 "legal.fsm"
case 2:
#line 218 "legal.fsm"
m->state = 3;
break;
#line 218 "legal.fsm"
case 3:
#line 218 "legal.fsm"
m->state = 4;
break;
#line 218 "legal.fsm"
case 4:
#line 218 "legal.fsm"
m->state = 5;
break;
#line 218 "legal.fsm"
case 5:
#line 218 "legal.fsm"
m->state = 6;
break;
#line 219 "legal.fsm"
case 6:
#line 219 "legal.fsm"
x->x = 0;
#line 219 "legal.fsm"
x->x += (*data) << 0;
#line 219 "legal.fsm"
m->state = 7;
break;
#line 219 "legal.fsm"
case 7:
#line 219 "legal.fsm"
x->x += (*data) << 8;
#line 219 "legal.fsm"
m->state = 8;
break;
#line 220 "legal.fsm"
case 8:
#line 220 "legal.fsm"
x->y = 0;
#line 220 "legal.fsm"
x->y += (*data) << 0;
#line 220 "legal.fsm"
m->state = 9;
break;
#line 220 "legal.fsm"
case 9:
#line 220 "legal.fsm"
x->y += (*data) << 8;
#line 220 "legal.fsm"
m->state = 10;
break;
#line 221 "legal.fsm"
case 10:
#line 221 "legal.fsm"
x->global_packed = 0;
#line 221 "legal.fsm"
x->global_packed += (*data) << 0;
#line 221 "legal.fsm"
m->state = 11;
	if (x->global_packed & 0x80) {
		fsm_push_state(m, GLOBAL_PALATE);
		x->max_color = ((int)2) << (x->global_packed & 0x07);
		x->count = x->max_color * 3;
		x->x = x->y = 0;
	} else {
		fsm_push_state(m, NEXT_CHUNK);
	}
break;
#line 231 "legal.fsm"
case 11:
#line 231 "legal.fsm"
x->background = 0;
#line 231 "legal.fsm"
x->background += (*data) << 0;
#line 231 "legal.fsm"
m->state = 12;
break;
#line 232 "legal.fsm"
case 12:
#line 232 "legal.fsm"
x->aspect = 0;
#line 232 "legal.fsm"
x->aspect += (*data) << 0;
#line 232 "legal.fsm"
m->state = fsm_pop_state(m);
break;
#line 233 "legal.fsm"
case 13:
#line 233 "legal.fsm"
if (!(x->count)) {
#line 233 "legal.fsm"
m->state = NEXT_CHUNK;
}
		x->palate[x->x][x->y] = *data;
		x->y++;
		if (x->y == 3) {
			x->y = 0;
			x->x++;
		}
		x->count--;
break;
#line 242 "legal.fsm"
case 14:
switch (*data) {
#line 243 "legal.fsm"
case 0x2c:
#line 243 "legal.fsm"
m->state = IMAGE_LEFT;
break;
#line 244 "legal.fsm"
case 0x21:
#line 244 "legal.fsm"
m->state = EXTENSION;
break;
#line 245 "legal.fsm"
default:
#line 245 "legal.fsm"
m->state = DIE;
break;
}
break;
#line 247 "legal.fsm"
case 15:
#line 247 "legal.fsm"
m->state = 16;
break;
#line 248 "legal.fsm"
case 16:
switch (*data) {
#line 249 "legal.fsm"
case 0:
#line 249 "legal.fsm"
m->state = NEXT_CHUNK;
break;
#line 250 "legal.fsm"
default:
#line 250 "legal.fsm"
x->count = (*data);
#line 250 "legal.fsm"
m->state = EXTENSION_DATA;
break;
}
break;
#line 252 "legal.fsm"
case 17:
#line 252 "legal.fsm"
if (!(x->count)) {
#line 252 "legal.fsm"
m->state = EXTENSION_COUNT;
}
break;
#line 253 "legal.fsm"
case 18:
#line 253 "legal.fsm"
x->left = 0;
#line 253 "legal.fsm"
x->left += (*data) << 0;
#line 253 "legal.fsm"
m->state = 19;
break;
#line 253 "legal.fsm"
case 19:
#line 253 "legal.fsm"
x->left += (*data) << 8;
#line 253 "legal.fsm"
m->state = 20;
break;
#line 254 "legal.fsm"
case 20:
#line 254 "legal.fsm"
x->top = 0;
#line 254 "legal.fsm"
x->top += (*data) << 0;
#line 254 "legal.fsm"
m->state = 21;
break;
#line 254 "legal.fsm"
case 21:
#line 254 "legal.fsm"
x->top += (*data) << 8;
#line 254 "legal.fsm"
m->state = 22;
break;
#line 255 "legal.fsm"
case 22:
#line 255 "legal.fsm"
x->width = 0;
#line 255 "legal.fsm"
x->width += (*data) << 0;
#line 255 "legal.fsm"
m->state = 23;
break;
#line 255 "legal.fsm"
case 23:
#line 255 "legal.fsm"
x->width += (*data) << 8;
#line 255 "legal.fsm"
m->state = 24;
break;
#line 256 "legal.fsm"
case 24:
#line 256 "legal.fsm"
x->height = 0;
#line 256 "legal.fsm"
x->height += (*data) << 0;
#line 256 "legal.fsm"
m->state = 25;
break;
#line 256 "legal.fsm"
case 25:
#line 256 "legal.fsm"
x->height += (*data) << 8;
#line 256 "legal.fsm"
m->state = 26;
break;
#line 257 "legal.fsm"
case 26:
#line 257 "legal.fsm"
x->image_packed = 0;
#line 257 "legal.fsm"
x->image_packed += (*data) << 0;
#line 257 "legal.fsm"
m->state = 27;
	x->x = x->y = 0;
	if ((*data) & 0x40)
		x->pass = 1;
	else
		x->pass = 0;
	if ((*data) & 0x80) {
		fsm_push_state(m, LOCAL_PALATE);
	} else {
		fsm_push_state(m, CODE_SIZE);
		if (x->global_packed & 0x80) {
			for (x->x = 0; x->x < 256; x->x++)
				for (x->y = 0; x->y < 3; x->y++)
					x->lpalate[x->x][x->y] =
						x->palate[x->x][x->y];
		}
	}
break;
#line 275 "legal.fsm"
case 27:
#line 275 "legal.fsm"
if (!(x->count)) {
#line 275 "legal.fsm"
m->state = CODE_SIZE;
}
		x->lpalate[x->x][x->y] = *data;
		x->y++;
		if (x->y == 3) {
			x->y = 0;
			x->x++;
		}
		x->count--;
break;
#line 284 "legal.fsm"
case 28:
#line 284 "legal.fsm"
x->code_size = 0;
#line 284 "legal.fsm"
x->code_size += (*data) << 0;
#line 284 "legal.fsm"
m->state = DATA_SIZE;
	x->start_code_size = x->code_size;
	x->code_mask = (2 << *data) - 1;
	x->clear_code = 1 << x->code_size;
	x->code_max = x->clear_code + 2;
	x->count = 0;
break;
#line 291 "legal.fsm"
case 29:
switch (*data) {
#line 292 "legal.fsm"
case 0:
#line 292 "legal.fsm"
m->state = NEXT_CHUNK;
break;
#line 293 "legal.fsm"
default:
#line 293 "legal.fsm"
x->count = (*data);
#line 293 "legal.fsm"
m->state = DATA;
break;
}
break;
#line 295 "legal.fsm"
case 30:
#line 295 "legal.fsm"
m->state = DATA_SIZE;
	unpack_byte(image, *data);
	x->count--;
break;
#line 299 "legal.fsm"
case 31:
#line 299 "legal.fsm"
m->state = DIE;
break;
}
data++, data_size--;
}
}
#line 304 "legal.fsm"
void image_addbytes_gif(struct image_struct *image,
	unsigned char *data, int count)
{
	struct gif_state *gif = malloc(sizeof(struct gif_state));
	int i;

	image->addbytes = parse_gif;
	image->private = gif;
	gif->x = 0;
	gif->y = 0;
	gif->count = 0;
	gif->code_acc = 0;
	gif->code_bits = 0;
	gif->code_old = 0;
	gif->first_byte = 1;
	for (i = 0; i < gif->clear_code; i++) {
		gif->tablep[i] = 0;
		gif->tablec[i] = i;
	}
	fsm_clear_environment(&gif->m);
	(*(image->addbytes))(image, data, count);
}

int image_identify_gif(unsigned char *data, size_t count)
{
	if (count < 6) return 0;

	if (data[0] != 'G') return 0;
	if (data[1] != 'I') return 0;
	if (data[2] != 'F') return 0;
	if (data[3] != '8') return 0;
	if ((data[4] != '7') && (data[4] != '9')) return 0;
	if (data[5] != 'a') return 0;
	return 1;
}
