/*   E-scape
     Copyright (C) 1997 Free Software Foundation, Inc.
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

/* Some of the definitions in this file mirror <X11/Intrinsic.h>.  Actually,
 * I may abondon compatiblity with that interface and build my own which is
 * more regular someday...
 */

#define XtInputReadMask ((XtPointer) 1)
#define XtInputWriteMask ((XtPointer) 2)
#define XtInputExceptMask ((XtPointer) 4)

typedef void * XtPointer;
typedef unsigned long XtInputId;

/* The following 5 lines were stolen from <X11/Intrinsic.h>.  If I reformat
 * it to two lines, will the lawyers call it 5 lines or 2 lines I took?
 */
typedef void (*XtInputCallbackProc)(
    XtPointer           /* closure */,
    int*                /* source */,
    XtInputId*          /* id */
);

struct _XtAppContext {
	XtInputId inputs;
};

typedef struct _XtAppContext *XtAppContext;

typedef struct _XtInputId_ {
	struct _XtInputId_ *back, *next;
	XtAppContext app;
	XtPointer call_data;
	XtPointer condition;
	XtInputCallbackProc proc;
	int fd;
} _XtInputId;

XtInputId XtAppAddInput(XtAppContext, int, XtPointer, XtInputCallbackProc,
	XtPointer);
XtAppContext NoXtInit(void);
void XtRemoveInput(XtInputId id);
void XtAppMainLoop(XtAppContext app);
